package server

import (
	pb "Jugadores/pb"
	"context"
	"fmt"
	"log"
	"math/rand"
	"net"
	"os"

	"google.golang.org/grpc"
)

var numeroJugador int32
var isNPC bool

type serverRonda struct {
	pb.UnimplementedRondaServer
}

func UNUSED(x ...interface{}) {}

func setNPC(NPC bool) {
	isNPC := NPC
	UNUSED(isNPC)
}

func setNumero(numero int32) {
	numeroJugador := numero
	if isNPC {
		fmt.Printf("Añadido NPC: %v", &numeroJugador)
	} else {
		fmt.Printf("Añadido jugador: %v", &numeroJugador)
	}
}

func addJugador(port string, NPC bool) {
	//Conexion
	conn, err := grpc.Dial("10.6.43.50:5000", grpc.WithInsecure())
	if err != nil {
		log.Fatal(err)
	}

	//Crear cliente para enviar el mensaje con la conexion
	client := pb.NewAddJugadorClient(conn)

	req := &pb.AddJugadorRequest{
		Address: "10.6.43.49" + port,
	}

	res, err := client.RequestAddJugador(context.Background(), req)
	if err != nil {
		log.Fatal(err)
	}

	print(res)
	print(res.NumeroJugador)
	setNPC(NPC)
	setNumero(res.NumeroJugador)
	defer conn.Close()
}

func getPlay(etapa int32, ronda int32, vivo bool) int32 {
	if etapa == 1 {
		for {
			if isNPC {
				fmt.Println("Ingrese su jugada (entre 1 y 10): ")
				var play int32
				fmt.Scanln(&play)
				if play > 0 && play < 11 {
					return play
				}
			} else {
				return int32(rand.Intn(10) + 1)
			}
		}
	}
	if etapa == 2 {
		return int32(rand.Intn(4) + 1)
	}
	if etapa == 3 {
		return int32(rand.Intn(10) + 1)
	}
	if etapa == 4 && vivo {
		fmt.Printf("Jugador %v ha ganado!", &numeroJugador)
		fmt.Scanln()
		os.Exit(1)
	}
	return 0
}

func (s *serverRonda) RequestRonda(ctx context.Context, Rrq *pb.RondaRequest) (*pb.RondaResponse, error) {
	etapa := Rrq.Etapa
	ronda := Rrq.Ronda
	vivo := Rrq.Vivo
	if !vivo {
		respon := &pb.RondaResponse{Jugada: 0,
			NumeroJugador: numeroJugador}
		return respon, nil
	}
	respon := &pb.RondaResponse{
		Jugada:        getPlay(etapa, ronda, vivo),
		NumeroJugador: numeroJugador,
	}
	return respon, nil
}

func StartServer(port string, NPC bool) {
	addJugador(port, NPC)

	grpcServer := grpc.NewServer()

	pb.RegisterRondaServer(grpcServer, &serverRonda{})

	listener, err := net.Listen("tcp", port)
	if err != nil {
		log.Fatal(err)
	}

	grpc_err := grpcServer.Serve(listener)
	if grpc_err != nil {
		log.Fatal(grpc_err)
	}
}
